var caiyuntabid;
var opencaiyun = false;
var openruletab = null;

function _generatePattern(url) {
    var domain = (/(https?:\/\/[^\/]*)\//gi.exec(url))[1];
    domain = domain + '*';
    return domain;
}
var caiyundomain="//www.caiyundata.cn";
// var caiyundomain="//caiyun.newssdk.com/";
// var caiyundomain="//cy.newssdk.com/";
function addRule(tab) {
    var that = this;
    return new Promise(function(resolve,reject){
    chrome.tabs.sendMessage(tab.id, { action: "checkifsetting" }, function(response) {
        chrome.storage.local.get({ "caiyuntabid": null }, function(items) {
            if (items.caiyuntabid) {
                return;
            }
            var postData = {
                "rule_name": tab.title,
                "rule_type": "2",
                "ua_type": "1",
                "url": tab.url,
                "url_pattern": _generatePattern(tab.url),
                "rid": '',
                "is_config": "2",
                "is_ajax": 2,
                "rule_mark": "",
                "extract_method": "csspath",
                // "category":33
            }
            getajax(caiyundomain+"/caiyun/rule/" + 'addrule', postData).then(function(res) {
                resolve(res)
                if (res.status == 1) {
                    if (res.data == 'notlogin') {
                        chrome.tabs.create({ url: "https:"+caiyundomain+'/default/index/login' })
                    }
                    else{
                        chrome.tabs.sendMessage(tab.id, { action: "showmsg" }, function(response) {});
                    }
                } else {
                    postData.rid = res.data.rid;
                    caiyuntabid = tab.id;
                    postData.rule_config = '{}'
                    chrome.storage.local.set({ caiyuntabid: tab.id, caiyunid: postData.rid, extratype: postData.rule_type, terminal_type: postData.ua_type, ifshow: true, url1: postData.url, domain: "https:"+caiyundomain }, function() {
                        chrome.tabs.sendMessage(tab.id, { action: "autoshowxzs", ruleData: postData,domain:"https:"+caiyundomain }, function(response) {});
                    });
                }
            }).catch(function(e) {
                chrome.tabs.sendMessage(tab.id, { action: "showmsg" }, function(response) {});
            })
        });

    })
    })
    // tools.post("https://www.caiyundata.cn/caiyun/rule/" + 'addrule', postData).then(function(res) {
    //     console.log(res)
    //     if (!!res) {
    //         if (!res.status) {
    //             $scope.safeApply(function() {
    //                 $scope.postData.rid = res.data.rid || $scope.postData.rid;

    //             });
    //         } else {
    //             layer.msg(res.statusinfo)
    //         }
    //     }
    // }).fail(function(e) {

    // });
}
chrome.browserAction.onClicked.addListener(function(tab) {
    addRule(tab);
})


function getQuery(url, name, issub) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = url.substr(url.indexOf('?') + 1).match(reg);
    if (r != null) return unescape(r[2]);
    return null;
}

chrome.runtime.onMessage.addListener(
    function(request, sender, sendResponse) {
        if (request.action && request.action == 'showtab') {
            chrome.tabs.get(request.opentabid, function(tab) {
                chrome.windows.update(tab.windowId, { focused: true }, function() {})
                chrome.tabs.highlight({ 'windowId': tab.windowId, 'tabs': tab.index }, function(windows) { console.log(windows) });
            });
        } else if (request.action && request.action == 'remove') {
            chrome.tabs.remove(request.opentabid, function() {
                chrome.storage.local.remove(['startcatch', 'caiyunid', 'caiyuntabid', 'caiyunprevconfig', 'clickdata', 'page_opentype', 'lastclickdata'], function() {})
                opencaiyun = false;
                caiyuntabid = null;
                sendResponse(true)
            });
        }
        // 从采云打开页面
        else if (request.action && request.action == 'open') {
            opencaiyun = true;
            // 获取打开小助手的父页面tabid
            chrome.tabs.query({
                active: true,
                windowId: chrome.windows.WINDOW_ID_CURRENT
            }, function(tabs) {
                if (tabs && tabs[0]) {
                    openruletab = tabs[0];
                    // 新建tab打开页面
                    if (request.url) {
                        chrome.windows.create({ url: request.url })
                    }
                }
            });



        }
        //从小助手请求tabid 
        else if (request.action == 'gettabid') {
            chrome.storage.local.get({ caiyuntabid: null, startcatch: true }, function(items) {
                // 如果是从原始网页打开的页面,重新在原网页打开这个网址，并将新窗口关闭
                console.log(sender, items)
                if (items.startcatch && sender.tab.openerTabId && sender.tab.openerTabId == items.caiyuntabid) {
                    chrome.storage.local.set({ "page_opentype": 1 })
                    chrome.tabs.update(items.caiyuntabid, {
                        url: sender.tab.url,
                        active: true
                    })
                    chrome.tabs.remove(sender.tab.id)
                }
                // 如果不是从原始网页打开的页面，把当前tabid返回
                else {
                    sendResponse(sender.tab.id)
                }
            });
            // });
        }
        // 打开帮助页面
        else if (request.action == 'openhelp') {
            if (request.url) {
                chrome.windows.create({ url: request.url })
            }
            // });
        }
        // 如果保存规格，则清理一下storage并设置caiyuntabid为null
        else if (request.action == 'saverule') {
            chrome.storage.local.remove(['startcatch', 'caiyunid', 'caiyuntabid', 'caiyunprevconfig', 'clickdata', 'page_opentype', 'lastclickdata'])
            if (!openruletab) {
                chrome.tabs.create({
                    url: request.url,
                    active: true
                }, function(tab) {

                })
                // chrome.tabs.remove(caiyuntabid);
                // chrome.storage.local.remove(['startcatch', 'caiyunid', 'caiyuntabid', 'caiyunprevconfig', 'clickdata', 'page_opentype', 'lastclickdata'], function() {})
                chrome.tabs.sendMessage(caiyuntabid, { action: "closexzs" }, function(response) {});
                openruletab = null;
                opencaiyun = false;
                caiyuntabid = null;
            } else {
                chrome.tabs.get(openruletab.id, function(tab) {
                    if (request.istask || !tab) {
                        chrome.tabs.create({
                            windowId: openruletab.windowId,
                            url: request.url,
                            active: true
                        }, function(tab) {

                        })
                    } else {
                        chrome.tabs.update(openruletab.id, {
                            url: request.url,
                            active: true
                        })
                        chrome.tabs.highlight({ 'windowId': tab.windowId, 'tabs': tab.index }, function(windows) {});
                    }
                    chrome.tabs.remove(caiyuntabid);
                    openruletab = null;
                    opencaiyun = false;
                    caiyuntabid = null;
                });
            }

        } else if (request.action = 'getrequest') {
            getajax(request.url, request.data).then(function(res) {
                if (res.data == 'notlogin') {
                    chrome.tabs.sendMessage(caiyuntabid, { action: "shownotlogin" }, function(response) {});
                }
                sendResponse(res)
            }).catch(function(e) {
                sendResponse(e)
            })
        }

        return true; //同步
    });
chrome.tabs.onCreated.addListener(function(tab) {
    // 如果是从采云打开的页面，设置caiyuntabid的值
    if (opencaiyun && !caiyuntabid) {
        chrome.storage.local.set({ caiyuntabid: tab.id }, function() {
            // console.log('设置tabid')
        });
        caiyuntabid = tab.id
        opencaiyun = false;
    }
})
chrome.tabs.onUpdated.addListener(function(tabid) {
    if (caiyuntabid == tabid) {
        chrome.tabs.sendMessage(tabid, { action: "showloading" }, function(response) {
            // if(callback) callback(response);
        });
    }
})
chrome.tabs.onRemoved.addListener(function(tabid) {
    // 如果关闭的标签是caiyun打开的tab，清理一下storage
    if (caiyuntabid == tabid) {
        chrome.storage.local.remove(['startcatch', 'caiyunid', 'caiyuntabid', 'caiyunprevconfig', 'clickdata', 'page_opentype', 'lastclickdata'], function() {})
        opencaiyun = false;
        caiyuntabid = null;
        openruletab = null;
    }
})

function getajax(url, data) {
    var data, type;
    type = 'application/x-www-form-urlencoded'
    if (typeof data == 'object') {
        data = makeFormData(data);
    } else {
        // type='application/json'
        // data=JSON.stringify(data);
    }
    return new Promise(function(resolve, reject) {
        ajax_method(url.indexOf('http')==0?url:('https:'+ url), data, 'post', type, function(res) {
            resolve(JSON.parse(res));
        }, function(e) {
            reject(e)
        })
    })
}

function ajax_method(url, data, method, type, success, error) {
    var ajax = new XMLHttpRequest();
    if (method == 'get') {
        if (data) {
            url += '?';
            url += data;
        } else {

        }
        ajax.open(method, url);
        ajax.send();
    } else {
        ajax.open(method, url);
        // xmlhttp.setRequestHeader("text/plain;charset=UTF-8");
        ajax.setRequestHeader("Content-type", type);
        if (data) {
            ajax.send(data);
        } else {
            ajax.send();
        }
    }
    ajax.onreadystatechange = function() {
        if (ajax.readyState == 4 && ajax.status == 200) {
            success(ajax.responseText);
        } else if (ajax.readyState == 4 && ajax.status != 200) {
            if (error) {
                error(ajax.responseText)
            }
        }
    }

}

function makeFormData(obj) {
    if (typeof obj == 'object') {

        let ret = ''
        for (let it in obj) {
            ret += encodeURIComponent(it) + '=' + encodeURIComponent(makeFormData(obj[it])) + '&'
        }
        return ret
    } else {
        return obj;
    }

}